(define-module (ui blockterm ajax)
    :use-module (alterator ajax)
    :use-module (alterator effect)
    :use-module (alterator woo)
    :export (init))

(define (act-save)
    (woo-write "/blockterm" "action" "save")
    (woo-write "/blockterm" 'pamcontrol (form-value "pamcontrol"))
    (update-effect)
)

(define (user-change)
    (ttylist-update)
    (blocked-update)
    (update-effect)
)

(define (blocked-update)
    (form-update-enum "blocked" (woo-list "/blockterm/blocked" 'user (form-value "userlist")))
)

(define (userlist-update)
    (form-update-enum "userlist" (woo-list "/blockterm/userlist"))
)

(define (ttylist-update)
    (form-update-enum "ttylist" (woo-list "/blockterm/ttylist" 'user (form-value "userlist")))
)

(define (ui-update)
    (userlist-update)
    (ttylist-update)
    (blocked-update)
    (form-update-value "pamcontrol" (woo-get-option (woo-read-first "/blockterm") 'pamcontrol))
    (update-effect)
)

(define (act-reset)
    (woo-write "/blockterm" "action" "reset")
    (ui-update)
)

(define (act-add)
    (woo-write "/blockterm/blockadd" 'user (form-value "userlist") 'tty (form-value "ttylist"))
    (ttylist-update)
    (blocked-update)
    (update-effect)
)

(define (act-rm)
    (woo-write "/blockterm/blockremove" 'user (form-value "userlist") 'tty (form-value "blocked"))
    (ttylist-update)
    (blocked-update)
    (update-effect)
)


(define (init)
    (init-effect)
    (form-bind "apply" "click" act-save)
    (form-bind "reset" "click" act-reset)
    (form-bind "add" "click" act-add)
    (form-bind "remove" "click" act-rm)
    (form-bind "userlist" "change" user-change)
    (act-reset)
)
