(document:surround "/std/frame")
(po-domain "alterator-secsetup")
;;; Vars

;;; UI
(vbox margin 10 align "top"
    (label text (bold (_ "Security options")))
    (separator)
    (groupbox title (_ "Access configuration")
        (vbox align "top"
        (checkbox name "pamcontrol" text (_ "block option enabled"))
        (gridbox columns "40;60" align "top"
            (vbox align "top"
                (label text (_ "User list"))
                (listbox name "userlist" (when selected (user-change)))
            )

            (groupbox title (_ "Block TTY")
                (gridbox columns "45;10;45"
                    (label text (_ "TTY list"))
                    (spacer)
                    (label text (_ "Blocked TTY"))

                    (checklistbox name "ttylist")
                    (vbox align "center"
                        (button text ">>" (when clicked (act-add)))
                        (button text "<<" (when clicked (act-rm)))
                    )
                    (checklistbox name "blocked")
                )
            )
        )
        )
    )

    (hbox align "left"
        (button text (_ "Apply") align "left" (when clicked (act-save)))
        (button text (_ "Reset") align "left" (when clicked (act-reset)))
    )
)

;; Logic
(define (act-save)
    (woo-write "/blockterm" "action" "save")
    (woo-write "/blockterm" 'pamcontrol (form-value "pamcontrol"))
)

(define (user-change)
    (ttylist-update)
    (blocked-update)
)

(define (blocked-update)
    (form-update-enum "blocked" (woo-list "/blockterm/blocked" 'user (form-value "userlist")))
)

(define (userlist-update)
    (form-update-enum "userlist" (woo-list "/blockterm/userlist"))
)

(define (ttylist-update)
    (form-update-enum "ttylist" (woo-list "/blockterm/ttylist" 'user (form-value "userlist")))
)

(define (ui-update)
    (userlist-update)
    (ttylist-update)
    (blocked-update)
    (form-update-value "pamcontrol" (woo-get-option (woo-read-first "/blockterm") 'pamcontrol))
)

(define (act-reset)
    (woo-write "/blockterm" "action" "reset")
    (ui-update)
)

(define (act-add)
    (woo-write "/blockterm/blockadd" 'user (form-value "userlist") 'tty (form-value "ttylist"))
    (ttylist-update)
    (blocked-update)
)

(define (act-rm)
    (woo-write "/blockterm/blockremove" 'user (form-value "userlist") 'tty (form-value "blocked"))
    (ttylist-update)
    (blocked-update)
)

(document:root
  (when loaded
       (ui-update)
  )
)
