(define-module (ui secsetup ajax)
    :use-module (alterator ajax)
    :use-module (alterator effect)
    :use-module (alterator woo)
    :export (init))


(define clk (lambda () 
    (form-update-visibility "integtxt" (woo-get-option (woo-read-first "/secsetup") 'integis))
))

(define (act-save)
    (woo-write "/secsetup"
        'macrosblock (form-value "mblock")

        'altha_nosuid (form-value "altha_nosuid_cb")
        'altha_rstrscript (form-value "altha_rstrscript_cb")
        'altha_olock (form-value "altha_olock_cb")
        'altha_nosuid_exceptions (form-value "altha_nosuid_edit")
        'altha_rstrscript_interpreters (form-value "altha_rstrscript_edit")
        'altha_olock_dirs (form-value "altha_olock_edit")

        'enable_gost (form-value "enable_gost")
    )
    (act-reset)
)

(define (act-reset)
    (let ((data (woo-read-first "/secsetup")))
        (form-update-value "mblock" (woo-get-option data 'chblk))
        (form-update-visibility "altha_box" (woo-get-option data 'altha))
        (form-update-visibility "altha_text" (not (woo-get-option data 'altha)))

        (form-update-value "altha_nosuid_cb" (woo-get-option data 'altha_nosuid))
        (form-update-value "altha_rstrscript_cb" (woo-get-option data 'altha_rstrscript))
        (form-update-value "altha_olock_cb" (woo-get-option data 'altha_olock))

        (form-update-value "altha_nosuid_edit" (woo-get-option data 'altha_nosuid_exceptions))
        (form-update-value "altha_rstrscript_edit" (woo-get-option data 'altha_rstrscript_interpreters))
        (form-update-value "altha_olock_edit" (woo-get-option data 'altha_olock_dirs))

        (form-update-value "enable_gost" (woo-get-option data 'enable_gost))
    )
    (update-effect)
)

(define (init)
    (init-effect)
    (form-update-visibility "integtxt" #f)
    (act-reset)
    (form-bind "mblock" "change" clk)
    (form-bind "apply" "click" act-save)
    (form-bind "reset" "click" act-reset)
)