(document:surround "/std/frame")

;;; Vars
(define msg (_ "Attention!!! You have the «integalert» application from the «settings-s» package installed; this may lead to incorrect loading of the OS. For details please refer to the integalert application documentation."))

;;; UI
(vbox margin 10 align "top"
    (label text (bold (_ "Security options")))
    (separator)
    (checkbox name "mblock" text (_ "block application macros"))
    (checkbox name "enable_gost" text (_ "use GOST R 34.11-2012 hash algorithm for user passwords"))
    (textbox text (bold msg) name "integtxt" visibility #f max-height 100)
    (groupbox title (_ "Alt Hardening")
        (label text (_ "Alt Hardening module is inactive") name "altha_text")
        (gridbox columns "0;100" align "top" name "altha_box"
            (checkbox colspan 2 name "altha_nosuid_cb" text (_ "disable SUID bit effect on child process privileges"))
            (label (_ "exceptions: "))
            (edit width 500 align "left" name "altha_nosuid_edit")

            (checkbox colspan 2 name "altha_rstrscript_cb" text (_ "restrict launch of programming language interpreters in interactive mode"))
            (label (_ "interpreters: "))
            (edit width 500 align "left" name "altha_rstrscript_edit")

            (checkbox colspan 2 name "altha_olock_cb" text (_ "disable deleting open files"))
            (label (_ "directories: "))
            (edit width 500 align "left" name "altha_olock_edit")
        )
    )

    (hbox align "left"
        (button text (_ "Apply") align "left" (when clicked (act-save)))
        (button text (_ "Reset") align "left" (when clicked (act-reset)))
    )
)

;;; Logic
(define clk (lambda () 
    (form-update-visibility "integtxt" (woo-get-option (woo-read-first "/secsetup") 'integis))
))

(define (act-save)
    (woo-write "/secsetup"
        'macrosblock (form-value "mblock")

        'altha_nosuid (form-value "altha_nosuid_cb")
        'altha_rstrscript (form-value "altha_rstrscript_cb")
        'altha_olock (form-value "altha_olock_cb")
        'altha_nosuid_exceptions (form-value "altha_nosuid_edit")
        'altha_rstrscript_interpreters (form-value "altha_rstrscript_edit")
        'altha_olock_dirs (form-value "altha_olock_edit")

        'enable_gost (form-value "enable_gost")
    )
)

(define (act-reset)
    (let ((data (woo-read-first "/secsetup")))
        (form-update-value "mblock" (woo-get-option data 'chblk))
        (form-update-visibility "altha_box" (woo-get-option data 'altha))
        (form-update-visibility "altha_text" (not (woo-get-option data 'altha)))

        (form-update-value "altha_nosuid_cb" (woo-get-option data 'altha_nosuid))
        (form-update-value "altha_rstrscript_cb" (woo-get-option data 'altha_rstrscript))
        (form-update-value "altha_olock_cb" (woo-get-option data 'altha_olock))

        (form-update-value "altha_nosuid_edit" (woo-get-option data 'altha_nosuid_exceptions))
        (form-update-value "altha_rstrscript_edit" (woo-get-option data 'altha_rstrscript_interpreters))
        (form-update-value "altha_olock_edit" (woo-get-option data 'altha_olock_dirs))

        (form-update-value "enable_gost" (woo-get-option data 'enable_gost))
    )
)

(form-bind "mblock" "change" clk)

(document:root
  (when loaded
       (act-reset)
  )
)
